
//百度地图对象
var bMap;

var base_api = {
    //基础配置类
    config: {
        //请求IP
        ajaxIp: "http://47.89.54.228:8888",
        //接口地址
        ajaxUrl: "/DInterface/app.ashx"
    },
    //跨域异步请求，支持文件上传
    ajax: function (opt) {
        //显示加载条
        base_api.loadShow();
        var _ajaxIp = base_api.ls.get("ajaxIp");
        var _ajaxUrl = base_api.ls.get("ajaxUrl");
        var _parms = (opt.parms == undefined ? {} : opt.parms);
        //alert(JSON.stringify(_parms));
        //参数组合
        opt = $.extend({
            url: 'http://' + (_ajaxIp == "" ? base_api.config.ajaxIp : _ajaxIp)
                + (_ajaxUrl == "" ? base_api.config.ajaxUrl : _ajaxUrl)
                + (opt.cmd == undefined ? "" : "?cmd=" + opt.cmd),
            fun: function (a, b) { }
        }, opt);
        //api.connectionType
        //提交方式
        api.ajax({
            url: opt.url,
            method: 'post',
            dataType: 'text',
            returnAll: false,
            //timeout: 30,
            data: {
                values: _parms,
                files: {
                    //file: 'fs://a.gif'
                }
            }
        }, function (ret, err) {
            opt.fun(ret, err);
            base_api.loadHide();
        });
    },
    /********************************其他功能 begin*******************************/
    //是否开启了GPS定位功能
    //获取当前手机gps状态，
    //对于安卓手机为当前手机gps状态，
    //对于苹果手机则是获取当前手机是否被用户同意了gps权限。
    //==============收费模块=============
    //http://apicloud.com/mod_detail?mdId=9620
    isgps: function (_f) {
        if (this.gpsmodel == undefined)
            this.gpsmodel = api.require('gpsState');
        this.gpsmodel.gpsstate(function (ret) {
            //alert(JSON.stringify(ret));
            if (_f != undefined && typeof (_f) == 'function') _f(ret);
        });
    },
    //设置是否禁止屏幕休眠
    jzxm: function () {
        api.setKeepScreenOn({
            keepOn: true
        });
    },
    //头部沉浸式
    cjs: function (dom, _f) {
        //获取系统类型
        var sysType = api.systemType;
        //获取当前版本
        var sv = api.systemVersion;
        var _paddingTop = 0;
        //是否支持沉浸式
        if (api.statusBarAppearance) {
            if (sysType == 'ios') {
                //截取系统版本 第一位
                var numSV = sv.charAt(0);
                //IOS 7 以上才有沉浸式的内增高动作
                if (numSV >= 7 && !api.fullScreen && api.statusBarAppearance) {
                    $(dom).css({
                        "padding-top": "20px"
                    });
                    _paddingTop = 20;
                }
            } else if (sysType == 'android') {
                var _zhi = ('' + sv).replace(/\./g, '');
                //alert(_zhi);
                //android 4.4 以上才有沉浸式的内增高动作
                if ((_zhi.length == 3 && _zhi >= 440) || (_zhi.length == 2 && _zhi >= 44)) {
                    $(dom).css({
                        "padding-top": "25px"
                    });
                    _paddingTop = 25;
                }
            }
        }
        if (_f != undefined && typeof (_f) == 'function') _f(_paddingTop);
    },
    //加载显示
    loadShow: function (opt) {
        //累计load数量
        if (base_api.loadShowIndex == undefined) base_api.loadShowIndex = 0;
        base_api.loadShowIndex = base_api.loadShowIndex + 1;
        //配置
        opt = $.extend(true, {
            style: 'default',
            animationType: 'fade',
            title: '处理中',
            text: '请耐心等待...',
            modal: true
        }, opt);
        api.showProgress(opt);
    },
    //加载隐藏
    loadHide: function () {
        api.hideProgress();
    },
    /********************************其他功能 end*******************************/
    /********************************DataConverter数据类型转换 begin*******************************/
    DataConverter: {
        //转换int类型
        toInt: function (val, moren) {
            if (moren == undefined) moren = 0;
            if (val == undefined) return moren;
            var v = parseInt(val);
            if (isNaN(v)) v = moren;
            return v;
        },
        //转换成带小数点数字
        toFolat: function (_value1, _default) {
            if (_default == undefined) _default = 0;
            if (_value1 == undefined) return _default;
            var v = parseFloat(_value1);
            if (isNaN(v)) v = _default;
            return v;
        },
        //是否是数字
        isFinite: function (_value1) {
            var v = isFinite(_value1);
            return v;
        }
    },
    /********************************DataConverter数据类型转换 end*******************************/
    /********************************json操作 begin*******************************/
    json: {
        //参数解说
        /*
        _obj:需要操作的json对象 
        _key1：需要取得节点名, 
        _value1：如果节点不存在时，需要返回的默认值
        */
        get: function (_obj, _key1, _value1) {
            if (_value1 == undefined) _value1 = "";
            if (!this.is(_obj, _key1)) { return _value1; }
            return _obj["" + _key1];
        },
        //是否存在节点
        is: function (_obj, _key1) {
            return ("" + _key1 in _obj);
        }
    },
    /********************************json操作 end*******************************/
    /********************************本地存储localStorage begin*******************************/
    ls: {
        //删除数据
        del: function (key) {
            if (window.localStorage) {
                window.localStorage.removeItem(key);
            } else {
                //当前浏览器不支持 localStorage
                api.removePrefs({
                    key: key
                });
            }
        },
        //获取数据
        get: function (key) {
            if (window.localStorage) {
                var retStr = '';
                retStr = window.localStorage.getItem(key);
                if (retStr == null) retStr = '';
                if (retStr == undefined) retStr = '';
                return retStr;
            } else {
                //当前浏览器不支持 localStorage
                return api.getPrefs({
                    sync: true,
                    key: key
                });
            }
            return '';
        },
        //存储数据
        set: function (key, val) {
            if (window.localStorage) {
                this.del(key);
                window.localStorage.setItem(key, val);
            } else {
                //当前浏览器不支持 localStorage
                api.setPrefs({
                    key: key,
                    value: val
                });
            }
        }
    },
    /********************************本地存储localStorage end*******************************/
    /********************************监听事件 begin*******************************/
    jt: {
        //发送监听内容
        set: function (name, data) {
            api.sendEvent({
                name: '' + name + '',
                extra: data
            });
        },
        //获取监听内容
        get: function (name, show) {
            api.addEventListener({
                name: name
            }, function (ret, err) {
                show(ret.value);
            });
        },
        //移除监听
        del: function (name) {
            api.removeEventListener({
                name: '' + name + ''
            });
        },
        //监听状态栏点击事件
        jtzhuangtailan: function (show) {
            api.addEventListener({
                name: 'noticeclicked'
            }, function (ret, err) {
                show(ret);
            });
        }
    },
    /********************************监听事件 end*******************************/
    end: function () { }
};