
//百度地图对象
var bMap;

var bmap_api = {
    //加载模块
    require: function () {
        if (bMap == undefined)
            bMap = api.require('aMap');
    },
    //打开地图定位
    /*
    开始定位，若要支持后台定位需配置 config.xml 文件 location 字段，
    无需调用 open 接口即可定位。
    在 android 平台上，离线定位功能需要手动打开GPS，并在无遮挡物的室外
    */
    dw: function (_f) {
        //加载模块
        this.require();
        if (_f == undefined) {
            //结束定位
            bMap.stopLocation();
            return;
        }
        //获取定位信息
        bMap.getLocation({
            autoStop: false
        },function(ret, err) {
            if (ret.status) {
                if (_f != undefined && typeof (_f) == 'function') _f(ret, JSON.stringify(ret), err);
            } else {
                alert("当前设备未开启定位权限，异常:"+err.code);
            }
        });
        // bMap.getLocation({
        //     accuracy: '10m',
        //     autoStop: false,
        //     filter: 1
        // }, function (ret, err) {
        //     if (ret.status) {
        //         //alert(JSON.stringify(ret));
        //         if (_f != undefined && typeof (_f) == 'function') _f(ret, JSON.stringify(ret), err);
        //     } else {
        //         alert("当前设备未开启定位权限，异常:"+err.code);
        //     }
        // });
    },
    //是否开启了定位功能
    isdw: function (_f1,_f2) {
        bMap.getLocationServices(function (ret, err) {
            if (ret.enable) {
                //alert(JSON.stringify(ret));
                _f1(ret,err);
            } else {
                //alert("未开启定位功能！");
                _f2(ret,err);
            }
        });
    },
    //测试距离
    /*
    获取地图两点之间的距离，
    无需调用 open 接口即可使用
    */
    jl: function (_f, _start, _end) {
    	//加载模块
        this.require();
        bMap.getDistance({
            start: _start,
            end: _end
        }, function (ret) {
            if (ret.status) {
                alert("距离："+ret.distance); 
            }
            if (_f == undefined && typeof (_f) == 'function') _f(ret.distance, ret.status);
        });
    },
    //打开百度地图
    dk: function (opt,callback) {
        //加载模块
        this.require();
        //参数组合
        opt = $.extend({
            rect: {
                x: 0,
                y: 0,
                w: 480,
                h: 600
            },
            center: {
                lon: 121.641111,
                lat: 29.883153
            },
            zoomLevel: 12,
            showUserLocation: false,
            fixedOn: api.frameName,
            fixed: true
        }, opt);
        //打开地图
        bMap.open(opt, function (ret) {
            if (ret.status) {
                callback(ret);
            } else {
                alert('地图打开失败');
            }
        });
    },
    //隐藏地图
    yc: function () {
        bMap.hide();
    },
    /*****************覆盖物 begin************************/
    //画线
    hx: function (opt) {
        //加载模块
        this.require();
        //是否有值
        if (bmap_api.hx_id == undefined) bmap_api.hx_id = 0;
        //累计值
        bmap_api.hx_id = bmap_api.hx_id + 1;
        //参数组合
        opt = $.extend({
            id: bmap_api.hx_id,
            styles: {
                borderColor: (opt.color == undefined ? '#FF0000' : opt.color),
                borderWidth: (opt.width == undefined ? 3 : opt.width)
            },
            points: (opt.poi == undefined ? [] : opt.poi)
        }, opt);
        bMap.addLine(opt);
        /* 添加起始结束点 */
        if (opt.poi != undefined && opt.poi.length > 2){
            bMap.addAnnotations({
                annotations: [{
                    id: 1,
                    lon: opt.poi[0].lon,
                    lat: opt.poi[0].lat
                },{
                    id: 2,
                    lon: opt.poi[opt.poi.length-1].lon,
                    lat: opt.poi[opt.poi.length-1].lat
                }],
                icons: ['widget://map/images/start.png'],
            }, function(ret) {

            });
            bMap.addAnnotations({
                annotations: [{
                    id: 2,
                    lon: opt.poi[opt.poi.length-1].lon,
                    lat: opt.poi[opt.poi.length-1].lat
                }],
                icons: ['widget://map/images/end.png'],
            }, function(ret) {

            });
        }

    },
    /*****************覆盖物 end************************/
    end: function () { }
};